VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmDemo 
   Caption         =   "Keithley Model 2000 with Scanner Card & RS-232 Interface"
   ClientHeight    =   8985
   ClientLeft      =   2010
   ClientTop       =   1755
   ClientWidth     =   7770
   Icon            =   "frmDemo.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   8985
   ScaleWidth      =   7770
   Begin VB.CommandButton cmdScan 
      Caption         =   "Execute List Commands"
      Height          =   735
      Left            =   4920
      TabIndex        =   9
      Top             =   3720
      Width           =   1095
   End
   Begin VB.ListBox lstCmds 
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5010
      ItemData        =   "frmDemo.frx":030A
      Left            =   960
      List            =   "frmDemo.frx":030C
      TabIndex        =   8
      Top             =   3720
      Width           =   3705
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4560
      TabIndex        =   7
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton cmdInstruct 
      Caption         =   "Show Instructions"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2640
      TabIndex        =   6
      Top             =   3120
      Width           =   1695
   End
   Begin VB.TextBox txtDmmOutput 
      Appearance      =   0  'Flat
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1125
      Left            =   2040
      MultiLine       =   -1  'True
      TabIndex        =   2
      Text            =   "frmDemo.frx":030E
      Top             =   1800
      Width           =   4455
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Top             =   3120
      Width           =   1335
   End
   Begin VB.TextBox txtCommand 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2040
      TabIndex        =   0
      Text            =   "Enter DMM command here"
      ToolTipText     =   "Try something like *IDN?"
      Top             =   1200
      Width           =   4455
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   120
      Top             =   3840
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      Handshaking     =   1
      InputLen        =   1024
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Label3 - Filled in via code"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   345
      TabIndex        =   5
      Top             =   120
      Width           =   6375
      WordWrap        =   -1  'True
   End
   Begin VB.Label Label2 
      Caption         =   "DMM Output:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   840
      TabIndex        =   4
      Top             =   1800
      Width           =   1140
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Command:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   720
      TabIndex        =   3
      Top             =   1200
      Width           =   1140
   End
End
Attribute VB_Name = "frmDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Alan Ivons / Dale Cigoy
' Keithley Instruments, Inc.
' 26 April 2000

Option Explicit

Private Sub cmdExecute_Click()
    Dim strBuffer As String     ' Without specifying length, string will hold ~2 billion chars

    
    MSComm1.PortOpen = True     ' Open RS-232 port for communications
   

    MSComm1.Output = txtCommand.Text & Chr(13)  ' Send Commmand concatenated with CR to DMM

    If Right(txtCommand.Text, 1) = "?" Then     ' If DMM Output is expected, then read it
        Do
            strBuffer = strBuffer & MSComm1.Input
        Loop Until Right$(strBuffer, 1) = Chr(13)   ' DMM output complete when a CR is received

        txtDmmOutput.Text = strBuffer   ' Display strBuffer in DMM Output textbox

        strBuffer = ""      ' Set strBuffer to a NULL string
    End If

    MSComm1.PortOpen = False    ' Close RS-232 port

End Sub

Private Sub cmdExit_Click()
    Unload frmDemo      ' Unload the Demo form

End Sub

Private Sub cmdInstruct_Click()
    frmInstruct.Show    ' Show the Instruction form

End Sub

Private Sub cmdScan_Click()
' send commands from the list box
 Dim strBuffer As String   ' Without specifying length, string will hold ~2 billion chars
 ' but MSCOMM does not like a string with a length defined!
 MSComm1.PortOpen = True     ' Open RS-232 port for communications
 
 Dim i As Integer
 For i = 0 To lstCmds.ListCount - 1
 lstCmds.ListIndex = i
 strBuffer = lstCmds.Text
  MSComm1.Output = strBuffer & Chr(13)  ' Send Commmand concatenated with CR to DMM
  strBuffer = ""
 Next i
' delay long enough for the measurements to complete
Delay (3)   ' delay 3 seconds
Beep
' read back the data with :TRAC:DATA? command
strBuffer = ":TRAC:DATA?"
MSComm1.Output = strBuffer & Chr(13)

 strBuffer = ""
Do
 strBuffer = strBuffer & MSComm1.Input
 DoEvents
Loop Until Right$(strBuffer, 1) = Chr(13)   ' DMM output complete when a CR is received

txtDmmOutput.Text = strBuffer

MSComm1.PortOpen = False    ' Close RS-232 port
End Sub

Private Sub Form_Load()
    Label3.Caption = "* Enter a command into the Command textbox." & vbCrLf _
    & "* Press Execute to send the command to the DMM." & vbCrLf _
    & "* Data returned from the DMM will be displayed in DMM Output textbox."
    
    ' populate list box with commands
lstCmds.AddItem "*RST"      'Clear registers)
lstCmds.AddItem "*CLS"       'Clear Model 2000
lstCmds.AddItem ":INIT:CONT OFF;:ABORT"    'Init off
lstCmds.AddItem ":SENS:FUNC 'TEMP'"       'Temperature function
 lstCmds.AddItem ":SENS:TEMP:NPLC 0.1"
lstCmds.AddItem ":SENS:TEMP:TC:TYPE K"
lstCmds.AddItem ":SENS:TEMP:TC:RJUN:RSEL REAL"  'using the CJC on the TC-SCAN card
lstCmds.AddItem ":SENS:TEMP:TC:RJUN:REAL:TCO .0002"
lstCmds.AddItem ":SENS:TEMP:TC:RJUN:REAL:OFFS .05463"
lstCmds.AddItem ":UNIT:TEMP C"   ' units of temp: C, F or K
lstCmds.AddItem ":SYST:AZER:STAT ON"        'Auto zero on
lstCmds.AddItem ":SENS:VOLT:DC:AVER:STAT OFF"    'Filter off
lstCmds.AddItem ":SENS:TEMP:DIG 7"       '6.5 digit
lstCmds.AddItem ":FORM:ELEM READ, CHAN"    'Send Reading and Chan in results
lstCmds.AddItem ":TRIG:COUN 1"           'Trig count 1
lstCmds.AddItem ":SAMP:COUN 4"             'Sample count 4
lstCmds.AddItem ":TRIG:DEL 0"              'No trigger delay
lstCmds.AddItem ":TRIG:SOUR IMM"           'Immediate trigger
lstCmds.AddItem ":ROUT:SCAN:INT (@2,3,4,5)"    'Set scan list
lstCmds.AddItem ":ROUT:SCAN:LSEL INT"       'Internal scan
lstCmds.AddItem ":TRAC:CLE"               'Clear buffer"
lstCmds.AddItem ":TRAC:POIN 4"          'Sample count 4
lstCmds.AddItem ":TRAC:FEED SENS"             'Feed
lstCmds.AddItem ":TRAC:FEED:CONT NEXT"
lstCmds.AddItem ":INIT"      'Start each scan"


    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' When the Demo form is unloaded, Reset the DMM, set it to LOCAL
    ' and then unload the Instruction form
   
    MSComm1.PortOpen = True
    MSComm1.Output = "*RST" & Chr(13)
    MSComm1.Output = ":SYSTEM:LOCAL" & Chr(13)
    MSComm1.PortOpen = False
    Unload frmInstruct

End Sub

Private Sub MSComm1_OnComm()
'Dim strBuffer As String * 50
'Do
 'strBuffer = strBuffer & MSComm1.Input
 'DoEvents
'Loop Until Right$(strBuffer, 1) = Chr(13)

'txtDmmOutput.Text = strBuffer
End Sub

Private Sub txtCommand_Change()
    txtDmmOutput.Text = ""
End Sub

Private Sub txtCommand_GotFocus()
    txtCommand.SelStart = 0
    txtCommand.SelLength = Len(txtCommand.Text)

End Sub

Sub Delay(sngSeconds As Single)
    
    Dim sngTargetTime As Single
    sngTargetTime = Timer + sngSeconds
    Do While sngTargetTime > Timer
        DoEvents
    Loop
    
End Sub
